// dumpwnd.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "wnd.h"

ULONG_PTR   g_base = 0;
WNDCLASSEX  wndclass = { 0x0 }; 

template <typename T>
T TranslatePointer ( const T pT )
{
   if ( (ULONG_PTR)(pT) <= g_base )
      return pT;
   return (T)((ULONG_PTR)pT - g_base);
}

void TranslateWnd ( WND * pWnd )
{
  pWnd->pSelf = TranslatePointer(pWnd->pSelf);
  pWnd->pFirstChild = TranslatePointer(pWnd->pFirstChild);
  pWnd->pNextWnd = TranslatePointer(pWnd->pNextWnd);
  pWnd->pParentWnd = TranslatePointer(pWnd->pParentWnd);
  pWnd->pText = TranslatePointer(pWnd->pText);
  pWnd->pWndClass = TranslatePointer(pWnd->pWndClass);
  pWnd->id.pMenu = TranslatePointer(pWnd->id.pMenu);
}

WND * GetWnd ( HWND hWnd )
{
   WND* pWnd = NULL;
   __asm {
      mov   eax, fs:[18h]
      lea   ebx, [eax + 6CCh]
      mov   ebx, dword ptr [ebx + 1Ch]
      mov   [g_base], ebx
      // calculate offset from the user32 shared section
      mov   ecx, 0x002F0000
      mov   eax, [hWnd]
      and   eax, 0xFFFF
      lea   eax, [eax + eax*2]
      lea   ecx, [ecx + eax*4]

      // calculate real address of pWnd
//      mov   eax, dword ptr [ebx + 18h]
      mov   esi, dword ptr [ecx]
      sub   esi, ebx
      mov   [pWnd], esi
   }
   return pWnd;
}

void DumpWnd ( WND * pWnd )
{
   printf ( "WND* at 0x%p (size %04x)\n", pWnd, sizeof(*pWnd) );
   printf ( "+%04x  HWND        hWnd         %08x\n", FIELD_OFFSET(WND, hWnd),        pWnd->hWnd );
   printf ( "+%04x  ULONG       unk1         %08x\n", FIELD_OFFSET(WND, unk1),        pWnd->unk1 );
   printf ( "+%04x  ULONG       unk2         %08x\n", FIELD_OFFSET(WND, unk2),        pWnd->unk2 );
   printf ( "+%04x  ULONG       unk3         %08x\n", FIELD_OFFSET(WND, unk3),        pWnd->unk3 );
   printf ( "+%04x  WND*        pSelf        %08x\n", FIELD_OFFSET(WND, pSelf),       pWnd->pSelf );
   printf ( "+%04x  DWORD       dwFlags      %08x\n", FIELD_OFFSET(WND, dwFlags),     pWnd->dwFlags );
      printf ( "\t\t ACTIVECAPTION: %d\n", pWnd->dwFlags & WF_ACTIVECAPTION );
      printf ( "\t\t UNICODE:       %d\n", !(pWnd->dwFlags & WF_ANSI) );

   printf ( "+%04x  ULONG       unk6         %08x\n", FIELD_OFFSET(WND, unk6),        pWnd->unk6 );
   printf ( "+%04x  DWORD       dwStyleEx    %08x\n", FIELD_OFFSET(WND, dwStyleEx),   pWnd->dwStyleEx );
   printf ( "+%04x  DWORD       dwStyle      %08x\n", FIELD_OFFSET(WND, dwStyle),     pWnd->dwStyle );
   printf ( "+%04x  HINSTANCE   hInstance    %08x\n", FIELD_OFFSET(WND, hInstance),   pWnd->hInstance );
   printf ( "+%04x  ULONG       unk10        %08x\n", FIELD_OFFSET(WND, unk10),       pWnd->unk10 );
   printf ( "+%04x  WND*        pNextWnd     %08x (%08x)\n", FIELD_OFFSET(WND, pNextWnd),    pWnd->pNextWnd, pWnd->pNextWnd ? pWnd->pNextWnd->hWnd : 0 );
   printf ( "+%04x  WND*        pParentWnd   %08x (%08x)\n", FIELD_OFFSET(WND, pParentWnd),  pWnd->pParentWnd, pWnd->pParentWnd ? pWnd->pParentWnd->hWnd : 0 );
   printf ( "+%04x  WND*        pFirstChild  %08x (%08x)\n", FIELD_OFFSET(WND, pFirstChild), pWnd->pFirstChild, pWnd->pFirstChild ? pWnd->pFirstChild->hWnd : 0 );
   printf ( "+%04x  WND*        pOwnerWnd    %08x (%08x)\n", FIELD_OFFSET(WND, pOwnerWnd),   pWnd->pOwnerWnd, pWnd->pOwnerWnd ? pWnd->pOwnerWnd->hWnd : 0 );
   printf ( "+%04x  RECT        rcWnd        {%d, %d, %d, %d}\n", FIELD_OFFSET(WND, rcWnd), 
            pWnd->rcWnd.left, pWnd->rcWnd.top, pWnd->rcWnd.right, pWnd->rcWnd.bottom );
   printf ( "+%04x  RECT        rcClient     {%d, %d, %d, %d}\n", FIELD_OFFSET(WND, rcClient), 
            pWnd->rcClient.left, pWnd->rcClient.top, pWnd->rcClient.right, pWnd->rcClient.bottom );
   printf ( "+%04x  WNDPROC*    pWndProc     %08x\n", FIELD_OFFSET(WND, pWndProc),    pWnd->pWndProc );

   TCHAR classname[1000] = {0x0}; GlobalGetAtomName ( pWnd->pWndClass->atomWindowType, classname, 1000 );
   printf ( "+%04x  WND_CLASS*  pWndClass    %08x (%s)\n", FIELD_OFFSET(WND, pWndClass),   pWnd->pWndClass, classname );
   printf ( "+%04x  ULONG       unk25        %08x\n", FIELD_OFFSET(WND, unk25),       pWnd->unk25 );
   printf ( "+%04x  ULONG       unk26        %08x\n", FIELD_OFFSET(WND, unk26),       pWnd->unk26 );
   printf ( "+%04x  ULONG       unk27        %08x\n", FIELD_OFFSET(WND, unk27),       pWnd->unk27 );
   printf ( "+%04x  ULONG       unk28        %08x\n", FIELD_OFFSET(WND, unk28),       pWnd->unk28 );
   printf ( "+%04x  WNDMENU*    pMenu(id)    %08x(%04x)\n", FIELD_OFFSET(WND, id.pMenu), pWnd->id.pMenu, pWnd->id.dwWndID );
   printf ( "+%04x  ULONG       unk30        %08x\n", FIELD_OFFSET(WND, unk30),       pWnd->unk30 );
   printf ( "+%04x  ULONG       unk31        %08x\n", FIELD_OFFSET(WND, unk31),       pWnd->unk31 );
   printf ( "+%04x  ULONG       unk32        %08x\n", FIELD_OFFSET(WND, unk32),       pWnd->unk32 );
   printf ( "+%04x  WCHAR       pText        \"%S\"\n",   FIELD_OFFSET(WND, pText),   pWnd->pText );
   printf ( "+%04x  DWORD       dwWndBytes   %08x\n", FIELD_OFFSET(WND, dwWndBytes),  pWnd->dwWndBytes );
   printf ( "+%04x  ULONG       unk35        %08x\n", FIELD_OFFSET(WND, unk35),       pWnd->unk35 );
   printf ( "+%04x  ULONG       unk36        %08x\n", FIELD_OFFSET(WND, unk36),       pWnd->unk36 );
   printf ( "+%04x  ULONG       wlUserData   %08x\n", FIELD_OFFSET(WND, wlUserData),  pWnd->wlUserData );
}

int main ( int argc, char* argv[] )
{
   if ( argc != 2 )
   {
      puts ( "usage: dumpwnd <hwnd>\nhwnd should be a hex number" );
      return 0;      
   }

   HWND hWnd = NULL;
   if ( sscanf ( argv[1], "%x", &hWnd ) < 1 || !IsWindow ( hWnd ) )
   {
      puts ( "Invalid hWnd" );
      return 0;
   }

   WND * pWnd = GetWnd ( hWnd );
   WINDOWINFO info = {0x0};
   GetWindowInfo ( hWnd, &info );

   WND wnd; memcpy ( &wnd, pWnd, sizeof(WND) );
   TranslateWnd ( &wnd );
   DumpWnd ( &wnd );
   
	return 0;
}
